package com.sto.express.utils;


import java.security.MessageDigest;
import java.security.spec.AlgorithmParameterSpec;

import javax.crypto.Cipher;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import javax.crypto.spec.IvParameterSpec;

/**
 * Des 加密
 *
 * @author qulixuan
 *  2018-1-18 20:42:41
 * Created by Administrator on 2017-09-22.
 */

public class AlgorithmUtil {
    private static final String ALGORITHM = "AES";
    private static final String TSFMN = "DES/CBC/PKCS5Padding";
    private static  AlgorithmParameterSpec iv = null;

    public AlgorithmUtil() {
    }


    //加密
    public static String  encrypt(String message, String key) throws Exception {
        // 加密key
        String firstKey = MD5Utils.digest(key).substring(0, 8).toUpperCase();
        String sha1 = getSha1(firstKey);
        sha1 = sha1.substring(0, 8).toUpperCase();
        byte[] bytes = sha1.getBytes();



        //加密iv
        String temp1 = MD5Utils.digest(key).substring(0, 8).toUpperCase();
        String upperCase = MD5Utils.digest(temp1).toUpperCase().substring(0, 8);
        byte[] bytes2 = upperCase.getBytes("ASCII");

       // UnsignedBytes
        Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");

        DESKeySpec desKeySpec = new DESKeySpec(bytes);

        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
        SecretKey secretKey = keyFactory.generateSecret(desKeySpec);
        IvParameterSpec iv = new IvParameterSpec(bytes2);
        cipher.init(Cipher.ENCRYPT_MODE, secretKey, iv);
        byte[] bytes1 = cipher.doFinal(message.getBytes("UTF-8"));
        String a = toHexString(bytes1).toUpperCase();
        return a;
    }

    // 解密数据
    public static String decrypt(String message, String key) throws Exception {

        // 加密key
        String firstKey = MD5Utils.digest(key).substring(0, 8).toUpperCase();
        String sha1 = getSha1(firstKey);
        sha1 = sha1.substring(0, 8).toUpperCase();
        byte[] bytes = sha1.getBytes();



        //加密iv
        String temp1 = MD5Utils.digest(key).substring(0, 8).toUpperCase();
        String upperCase = MD5Utils.digest(temp1).toUpperCase().substring(0, 8);
        byte[] bytes2 = upperCase.getBytes();


        byte[] bytesrc =convertHexString(message);
        Cipher cipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
        DESKeySpec desKeySpec = new DESKeySpec(bytes);
        SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
        SecretKey secretKey = keyFactory.generateSecret(desKeySpec);
        IvParameterSpec iv = new IvParameterSpec(bytes2);

        cipher.init(Cipher.DECRYPT_MODE, secretKey, iv);

        byte[] retByte = cipher.doFinal(bytesrc);
        return new String(retByte,"GBK");
    }
    // int转byte
    public static byte[] intToBytes(int value) {
        byte[] des = new byte[4];
        des[0] = (byte) (value & 0xff);  // 低位(右边)的8个bit位
        des[1] = (byte) ((value >> 8) & 0xff); //第二个8 bit位
        des[2] = (byte) ((value >> 16) & 0xff); //第三个 8 bit位
        /**
         * (byte)((value >> 24) & 0xFF);
         * value向右移动24位, 然后和0xFF也就是(11111111)进行与运算
         * 在内存中生成一个与 value 同类型的值
         * 然后把这个值强制转换成byte类型, 再赋值给一个byte类型的变量 des[3]
         */
        des[3] = (byte) ((value >> 24) & 0xff); //第4个 8 bit位
        return des;
    }



    public static byte[] convertHexString(String ss) {
        byte digest[] = new byte[ss.length() / 2];
        for (int i = 0; i < digest.length; i++) {
            String byteString = ss.substring(2 * i, 2 * i + 2);
            int byteValue = Integer.parseInt(byteString, 16);
            digest[i] =  (byte)byteValue;
        }

        return digest;
    }

    public static String toHexString(byte b[]) {
        StringBuffer hexString = new StringBuffer();
        for (int i = 0; i < b.length; i++) {
            String plainText = Integer.toHexString(0xff & b[i]);
            if (plainText.length() < 2)
                plainText = "0" + plainText;
            hexString.append(plainText);
        }

        return hexString.toString();
    }


    public static String getSha1(String str) {
        if (null == str || 0 == str.length()) {
            return null;
        }
        char[] hexDigits = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9',
                'a', 'b', 'c', 'd', 'e', 'f'};
        try {
            MessageDigest mdTemp = MessageDigest.getInstance("SHA1");
            mdTemp.update(str.getBytes("UTF-8"));

            byte[] md = mdTemp.digest();
            int j = md.length;
            char[] buf = new char[j * 2];
            int k = 0;
            for (int i = 0; i < j; i++) {
                byte byte0 = md[i];
                buf[k++] = hexDigits[byte0 >>> 4 & 0xf];
                buf[k++] = hexDigits[byte0 & 0xf];
            }
            return new String(buf);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return  null;
    }
}
